Index: branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 6850)
+++ branches/2016/dev_r6325_SIMPLIF_1/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 6851)
@@ -22,17 +22,22 @@
    !!             -   ! 2014-09  (F. Roquet)  add TEOS-10, S-EOS, and modify EOS-80
    !!             -   ! 2015-06  (P.A. Bouttier) eos_fzp functions changed to subroutines for AGRIF
+   !!             -   ! 2016-04  (F. Roquet) modify S-EOS as in Roquet et al. (JPO, 2015) + L-EOS
+   !!             -   ! 2016-04  (T. Graham, G. Madec) logicals instead of an integer as control of the EOS used
+   !!             -   ! 2016-07  (G. Madec, F. Roquet) generic freezing point for all EOS
    !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
    !!   eos           : generic interface of the equation of state
-   !!   eos_insitu    : Compute the in situ density
-   !!   eos_insitu_pot: Compute the insitu and surface referenced potential volumic mass
-   !!   eos_insitu_2d : Compute the in situ density for 2d fields
-   !!   bn2           : Compute the Brunt-Vaisala frequency
+   !!   eos_insitu    : compute the in situ density
+   !!   eos_insitu_pot: compute the insitu and surface referenced potential volumic mass
+   !!   eos_insitu_2d : compute the in situ density for 2d fields
    !!   eos_rab       : generic interface of in situ thermal/haline expansion ratio 
    !!   eos_rab_3d    : compute in situ thermal/haline expansion ratio
    !!   eos_rab_2d    : compute in situ thermal/haline expansion ratio for 2d fields
+   !!   bn2           : compute the Brunt-Vaisala frequency
+   !!   eos_pt_from_ct: compute potential temperature from conservative temperature
    !!   eos_fzp_2d    : freezing temperature for 2d fields
    !!   eos_fzp_0d    : freezing temperature for scalar
+   !!   eos_pen       : Potential Energy diagnostics
    !!   eos_init      : set eos parameters (namelist)
    !!----------------------------------------------------------------------
@@ -75,15 +80,22 @@
 
    !                               !!** Namelist nameos **
-   INTEGER , PUBLIC ::   nn_eos     ! = 0/1/2 type of eq. of state and Brunt-Vaisala frequ.
-   LOGICAL , PUBLIC ::   ln_useCT   ! determine if eos_pt_from_ct is used to compute sst_m
-
-   !                               !!!  simplified eos coefficients (default value: Vallis 2006)
-   REAL(wp) ::   rn_a0      = 1.6550e-1_wp     ! thermal expansion coeff. 
-   REAL(wp) ::   rn_b0      = 7.6554e-1_wp     ! saline  expansion coeff. 
-   REAL(wp) ::   rn_lambda1 = 5.9520e-2_wp     ! cabbeling coeff. in T^2        
-   REAL(wp) ::   rn_lambda2 = 5.4914e-4_wp     ! cabbeling coeff. in S^2        
-   REAL(wp) ::   rn_mu1     = 1.4970e-4_wp     ! thermobaric coeff. in T  
-   REAL(wp) ::   rn_mu2     = 1.1090e-5_wp     ! thermobaric coeff. in S  
-   REAL(wp) ::   rn_nu      = 2.4341e-3_wp     ! cabbeling coeff. in theta*salt  
+   !                                ! Choice of Equation Of Seawater (EOS)
+   LOGICAL , PUBLIC ::   ln_TEOS10     ! use the polyTEOS-10 EOS
+   LOGICAL , PUBLIC ::   ln_EOS80      ! use the polyEOS-80  EOS
+   LOGICAL , PUBLIC ::   ln_SEOS       ! use the Simplified EOS (Roquet et al. JPO 2015)
+   LOGICAL , PUBLIC ::   ln_LEOS       ! use a   Linear     EOS
+   !                                ! S-EOS coefficients (default value see Roquet et al. JPO 2015, Eq.17)
+   REAL(wp) ::   rn_a0, rn_b0, rn_cb, rn_t0, rn_th
+   REAL(wp) ::   rn_al, rn_bl       ! L-EOS coefficients
+
+   LOGICAL , PUBLIC    ::   l_useCT         ! =T in ln_TEOS10, ln_SEOS or ln_LEOS=T (i.e. use eos_pt_from_ct to compute sst_m), =F otherwise
+   INTEGER , PUBLIC    ::   neos            ! Identifier for equation of state used
+   INTEGER , PARAMETER ::   np_teos10 = -1  ! parameter for using TEOS-10
+   INTEGER , PARAMETER ::   np_eos80  =  0  ! parameter for using EOS-80
+   INTEGER , PARAMETER ::   np_seos   =  1  ! parameter for using Simplified EOS
+   INTEGER , PARAMETER ::   np_leos   =  2  ! parameter for using Linear     EOS
+
+   ! All EOS
+   REAL(wp) ::   rSA2SP    ! conversion factor from SA to SP (set to 1 for EOS-80)
    
    ! TEOS10/EOS80 parameters
@@ -169,4 +181,7 @@
    REAL(wp) ::   BPE002
 
+   ! S-EOS (L-EOS) parameters
+   REAL(wp) ::   SA0, SB0 , SCB , STH , ST0
+   
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
@@ -184,5 +199,5 @@
       !! ** Purpose :   Compute the in situ density (ratio rho/rau0) from
       !!       potential temperature and salinity using an equation of state
-      !!       defined through the namelist parameter nn_eos.
+      !!       selected in the nameos namelist
       !!
       !! ** Method  :   prd(t,s,z) = ( rho(t,s,z) - rau0 ) / rau0
@@ -194,20 +209,23 @@
       !!                rau0   reference density            kg/m^3
       !!
-      !!     nn_eos = -1 : polynomial TEOS-10 equation of state is used for rho(t,s,z).
+      !!     ln_TEOS10 : polynomial TEOS-10 Equation of Seawater is used for rho(t,s,z).
       !!         Check value: rho = 1028.21993233072 kg/m^3 for z=3000 dbar, ct=3 Celcius, sa=35.5 g/kg
       !!
-      !!     nn_eos =  0 : polynomial EOS-80 equation of state is used for rho(t,s,z).
+      !!     ln_EOS80  : polynomial EOS-80 Equation of Seawater is used for rho(t,s,z).
       !!         Check value: rho = 1028.35011066567 kg/m^3 for z=3000 dbar, pt=3 Celcius, sp=35.5 psu
       !!
-      !!     nn_eos =  1 : simplified equation of state
-      !!              prd(t,s,z) = ( -a0*(1+lambda/2*(T-T0)+mu*z+nu*(S-S0))*(T-T0) + b0*(S-S0) ) / rau0
-      !!              linear case function of T only: rn_alpha<>0, other coefficients = 0
-      !!              linear eos function of T and S: rn_alpha and rn_beta<>0, other coefficients=0
-      !!              Vallis like equation: use default values of coefficients
+      !!     ln_SEOS   : simplified Equation of Seawater (Eq. (17) of Roquet et al. JPO 2015)
+      !!                     rd(T,S,Z) = [-(a0+.5*cb*(T-T0)+th*Z)*(T-T0) + b0*(S-35) ] / rau0
+      !!
+      !!     ln_LEOS   : linear Equation of Seawater
+      !!                     rd(T,S,Z) = [ -al*(T-10) + bl*(S-35) ] / rau0
+      !!
+      !!     Note that both TEOS-10 and EOS-80 share a same polynomial expression
+      !!     Note that both S-EOS   and L-EOS  share a same polynomial expression 
       !!
       !! ** Action  :   compute prd , the in situ density (no units)
       !!
-      !! References :   Roquet et al, Ocean Modelling, in preparation (2014)
-      !!                Vallis, Atmospheric and Oceanic Fluid Dynamics, 2006
+      !! References :   Roquet et al. 2015, Ocean Modelling.
+      !!                Roquet et al. 2015, J. Phys. Oceanogr. 
       !!                TEOS-10 Manual, 2010
       !!----------------------------------------------------------------------
@@ -224,7 +242,7 @@
       IF( nn_timing == 1 )   CALL timing_start('eos-insitu')
       !
-      SELECT CASE( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE( neos )
+      !
+      CASE( np_teos10 , np_eos80 )        !==  polynomial TEOS-10 or EOS-80 ==!
          !
          DO jk = 1, jpkm1
@@ -266,18 +284,16 @@
          END DO
          !
-      CASE( 1 )                !==  simplified EOS  ==!
+      CASE( np_seos , np_leos )           !==  simplified or linear EOS  ==!
          !
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zt  = pts  (ji,jj,jk,jp_tem) - 10._wp
+                  zt  = pts  (ji,jj,jk,jp_tem) - ST0
                   zs  = pts  (ji,jj,jk,jp_sal) - 35._wp
                   zh  = pdep (ji,jj,jk)
                   ztm = tmask(ji,jj,jk)
                   !
-                  zn =  - rn_a0 * ( 1._wp + 0.5_wp*rn_lambda1*zt + rn_mu1*zh ) * zt   &
-                     &  + rn_b0 * ( 1._wp - 0.5_wp*rn_lambda2*zs - rn_mu2*zh ) * zs   &
-                     &  - rn_nu * zt * zs
-                     !                                 
+                  zn =  - ( SA0 + 0.5_wp*SCB * zt + STH * zh ) * zt + SB0 * zs
+                  !                                 
                   prd(ji,jj,jk) = zn * r1_rau0 * ztm                ! density anomaly (masked)
                END DO
@@ -299,11 +315,9 @@
       !!
       !! ** Purpose :   Compute the in situ density (ratio rho/rau0) and the
-      !!      potential volumic mass (Kg/m3) from potential temperature and
-      !!      salinity fields using an equation of state defined through the
-      !!     namelist parameter nn_eos.
+      !!      potential density (kg/m3) from temperature and salinity
+      !!       fields using the equation of state selected in the namelist.
       !!
       !! ** Action  : - prd  , the in situ density (no units)
-      !!              - prhop, the potential volumic mass (Kg/m3)
-      !!
+      !!              - prhop, the potential density (kg/m3)
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts    ! 1 : potential temperature  [Celcius]
@@ -322,13 +336,13 @@
       IF( nn_timing == 1 )   CALL timing_start('eos-pot')
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE ( neos )
+      !
+      CASE( np_teos10 , np_eos80 )               !==  polynomial TEOS-10 or EOS-80 ==!
          !
          ! Stochastic equation of state
          IF ( ln_sto_eos ) THEN
-            ALLOCATE(zn0_sto(1:2*nn_sto_eos))
-            ALLOCATE(zn_sto(1:2*nn_sto_eos))
-            ALLOCATE(zsign(1:2*nn_sto_eos))
+            ALLOCATE( zn0_sto(1:2*nn_sto_eos) )
+            ALLOCATE( zn_sto (1:2*nn_sto_eos) )
+            ALLOCATE( zsign  (1:2*nn_sto_eos) )
             DO jsmp = 1, 2*nn_sto_eos, 2
               zsign(jsmp)   = 1._wp
@@ -387,7 +401,7 @@
                END DO
             END DO
-            DEALLOCATE(zn0_sto,zn_sto,zsign)
-         ! Non-stochastic equation of state
-         ELSE
+            DEALLOCATE( zn0_sto, zn_sto, zsign )
+            ! 
+         ELSE                    ! Non-stochastic equation of state
             DO jk = 1, jpkm1
                DO jj = 1, jpj
@@ -430,20 +444,18 @@
          ENDIF
          
-      CASE( 1 )                !==  simplified EOS  ==!
+      CASE( np_seos , np_leos )                !==  simplified or linear EOS  ==!
          !
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zt  = pts  (ji,jj,jk,jp_tem) - 10._wp
+                  zt  = pts  (ji,jj,jk,jp_tem) - ST0
                   zs  = pts  (ji,jj,jk,jp_sal) - 35._wp
                   zh  = pdep (ji,jj,jk)
                   ztm = tmask(ji,jj,jk)
                   !                                                     ! potential density referenced at the surface
-                  zn =  - rn_a0 * ( 1._wp + 0.5_wp*rn_lambda1*zt ) * zt   &
-                     &  + rn_b0 * ( 1._wp - 0.5_wp*rn_lambda2*zs ) * zs   &
-                     &  - rn_nu * zt * zs
+                  zn =  - ( SA0 + 0.5_wp*SCB * zt ) * zt + SB0 * zs
                   prhop(ji,jj,jk) = ( rau0 + zn ) * ztm
                   !                                                     ! density anomaly (masked)
-                  zn = zn - ( rn_a0 * rn_mu1 * zt + rn_b0 * rn_mu2 * zs ) * zh
+                  zn = zn - STH * zh * zt
                   prd(ji,jj,jk) = zn * r1_rau0 * ztm
                   !
@@ -466,9 +478,8 @@
       !!
       !! ** Purpose :   Compute the in situ density (ratio rho/rau0) from
-      !!      potential temperature and salinity using an equation of state
-      !!      defined through the namelist parameter nn_eos. * 2D field case
+      !!      temperature and salinity using an equation of state
+      !!      selected in the nameos namelist. * 2D field case
       !!
       !! ** Action  : - prd , the in situ density (no units) (unmasked)
-      !!
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj,jpts), INTENT(in   ) ::   pts   ! 1 : potential temperature  [Celcius]
@@ -486,7 +497,7 @@
       prd(:,:) = 0._wp
       !
-      SELECT CASE( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE( neos )
+      !
+      CASE( np_teos10 , np_eos80 )               !==  polynomial TEOS-10 or EOS-80 ==!
          !
          DO jj = 1, jpjm1
@@ -527,17 +538,15 @@
          CALL lbc_lnk( prd, 'T', 1. )                    ! Lateral boundary conditions
          !
-      CASE( 1 )                !==  simplified EOS  ==!
+      CASE( np_seos , np_leos )                !==  simplified or linear EOS  ==!
          !
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
                !
-               zt    = pts  (ji,jj,jp_tem)  - 10._wp
+               zt    = pts  (ji,jj,jp_tem)  - ST0
                zs    = pts  (ji,jj,jp_sal)  - 35._wp
                zh    = pdep (ji,jj)                         ! depth at the partial step level
                !
-               zn =  - rn_a0 * ( 1._wp + 0.5_wp*rn_lambda1*zt + rn_mu1*zh ) * zt   &
-                  &  + rn_b0 * ( 1._wp - 0.5_wp*rn_lambda2*zs - rn_mu2*zh ) * zs   &
-                  &  - rn_nu * zt * zs
-                  !
+               zn =  - ( SA0 + 0.5_wp*SCB * zt + STH * zh ) * zt + SB0 * zs
+               !
                prd(ji,jj) = zn * r1_rau0               ! unmasked in situ density anomaly
                !
@@ -576,7 +585,7 @@
       IF( nn_timing == 1 )   CALL timing_start('rab_3d')
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE ( neos )
+      !
+      CASE( np_teos10 , np_eos80 )               !==  polynomial TEOS-10 or EOS-80 ==!
          !
          DO jk = 1, jpkm1
@@ -635,19 +644,17 @@
          END DO
          !
-      CASE( 1 )                  !==  simplified EOS  ==!
+      CASE( np_seos , np_leos )                  !==  simplified or linear EOS  ==!
          !
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zt  = pts (ji,jj,jk,jp_tem) - 10._wp   ! pot. temperature anomaly (t-T0)
+                  zt  = pts (ji,jj,jk,jp_tem) - ST0      ! pot. temperature anomaly (t-T0)
                   zs  = pts (ji,jj,jk,jp_sal) - 35._wp   ! abs. salinity anomaly (s-S0)
                   zh  = gdept_n(ji,jj,jk)                ! depth in meters at t-point
                   ztm = tmask(ji,jj,jk)                  ! land/sea bottom mask = surf. mask
                   !
-                  zn  = rn_a0 * ( 1._wp + rn_lambda1*zt + rn_mu1*zh ) + rn_nu*zs
-                  pab(ji,jj,jk,jp_tem) = zn * r1_rau0 * ztm   ! alpha
-                  !
-                  zn  = rn_b0 * ( 1._wp - rn_lambda2*zs - rn_mu2*zh ) - rn_nu*zt
-                  pab(ji,jj,jk,jp_sal) = zn * r1_rau0 * ztm   ! beta
+                  pab(ji,jj,jk,jp_tem) = ( SA0 + SCB * zt + STH * zh ) * r1_rau0 * ztm    ! alpha
+                  !
+                  pab(ji,jj,jk,jp_sal) =   SB0                         * r1_rau0 * ztm    ! beta
                   !
                END DO
@@ -657,5 +664,5 @@
       CASE DEFAULT
          IF(lwp) WRITE(numout,cform_err)
-         IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
+         IF(lwp) WRITE(numout,*) '          bad flag value for neos = ', neos
          nstop = nstop + 1
          !
@@ -668,4 +675,5 @@
       !
    END SUBROUTINE rab_3d
+
 
    SUBROUTINE rab_2d( pts, pdep, pab )
@@ -690,7 +698,7 @@
       pab(:,:,:) = 0._wp
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE ( neos )
+      !
+      CASE( np_teos10 , np_eos80 )               !==  polynomial TEOS-10 or EOS-80 ==!
          !
          DO jj = 1, jpjm1
@@ -750,18 +758,16 @@
          CALL lbc_lnk( pab(:,:,jp_sal), 'T', 1. )                    
          !
-      CASE( 1 )                  !==  simplified EOS  ==!
+      CASE( np_seos , np_leos )                  !==  simplified or linear EOS  ==!
          !
          DO jj = 1, jpjm1
             DO ji = 1, fs_jpim1   ! vector opt.
                !
-               zt    = pts  (ji,jj,jp_tem) - 10._wp   ! pot. temperature anomaly (t-T0)
+               zt    = pts  (ji,jj,jp_tem) - ST0      ! pot. temperature anomaly (t-T0)
                zs    = pts  (ji,jj,jp_sal) - 35._wp   ! abs. salinity anomaly (s-S0)
                zh    = pdep (ji,jj)                   ! depth at the partial step level
                !
-               zn  = rn_a0 * ( 1._wp + rn_lambda1*zt + rn_mu1*zh ) + rn_nu*zs
-               pab(ji,jj,jp_tem) = zn * r1_rau0   ! alpha
-               !
-               zn  = rn_b0 * ( 1._wp - rn_lambda2*zs - rn_mu2*zh ) - rn_nu*zt
-               pab(ji,jj,jp_sal) = zn * r1_rau0   ! beta
+               pab(ji,jj,jp_tem) = ( SA0 + SCB * zt + STH * zh ) * r1_rau0    ! alpha
+               !
+               pab(ji,jj,jp_sal) =   SB0                         * r1_rau0    ! beta
                !
             END DO
@@ -773,5 +779,5 @@
       CASE DEFAULT
          IF(lwp) WRITE(numout,cform_err)
-         IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
+         IF(lwp) WRITE(numout,*) '          bad flag value for neos = ', neos
          nstop = nstop + 1
          !
@@ -806,7 +812,7 @@
       pab(:) = 0._wp
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE ( neos )
+      !
+      CASE( np_teos10 , np_eos80 )        !==  polynomial TEOS-10 or EOS-80 ==!
          !
          !
@@ -858,20 +864,17 @@
          !
          !
-         !
-      CASE( 1 )                  !==  simplified EOS  ==!
-         !
-         zt    = pts(jp_tem) - 10._wp   ! pot. temperature anomaly (t-T0)
+      CASE( np_seos , np_leos )           !==  simplified or linear EOS  ==!
+         !
+         zt    = pts(jp_tem) - ST0      ! pot. temperature anomaly (t-T0)
          zs    = pts(jp_sal) - 35._wp   ! abs. salinity anomaly (s-S0)
-         zh    = pdep                    ! depth at the partial step level
-         !
-         zn  = rn_a0 * ( 1._wp + rn_lambda1*zt + rn_mu1*zh ) + rn_nu*zs
-         pab(jp_tem) = zn * r1_rau0   ! alpha
-         !
-         zn  = rn_b0 * ( 1._wp - rn_lambda2*zs - rn_mu2*zh ) - rn_nu*zt
-         pab(jp_sal) = zn * r1_rau0   ! beta
+         zh    = pdep                   ! depth at the partial step level
+         !
+         pab(jp_tem) = ( SA0 + SCB * zt + STH * zh ) * r1_rau0    ! alpha
+         !
+         pab(jp_sal) =   SB0                         * r1_rau0    ! beta
          !
       CASE DEFAULT
          IF(lwp) WRITE(numout,cform_err)
-         IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
+         IF(lwp) WRITE(numout,*) '          bad flag value for neos = ', neos
          nstop = nstop + 1
          !
@@ -885,15 +888,14 @@
    SUBROUTINE bn2( pts, pab, pn2 )
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE bn2  ***
+      !!                        ***  ROUTINE bn2  ***
       !!
       !! ** Purpose :   Compute the local Brunt-Vaisala frequency at the 
       !!                time-step of the input arguments
       !!
-      !! ** Method  :   pn2 = grav * (alpha dk[T] + beta dk[S] ) / e3w
+      !! ** Method  :   pn2 = grav * (a*dk[T] + b*dk[S] ) / e3w
       !!      where alpha and beta are given in pab, and computed on T-points.
       !!      N.B. N^2 is set one for all to zero at jk=1 in istate module.
       !!
       !! ** Action  :   pn2 : square of the brunt-vaisala frequency at w-point 
-      !!
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::  pts   ! pot. temperature and salinity   [Celcius,psu]
@@ -999,4 +1001,13 @@
       !!       checkvalue: tf=-2.588567 Celsius for s=40psu, z=500m
       !!
+      !!       Note1: ptf is the IN SITU freezing temperature. It is equal to the potential
+      !!              one when pdep=0 (or pdep is not present).
+      !!              Potential freezing point is what is needed by sea-ice model
+      !!       Note2: This formulation needs a salinity given in Practical Salinity Units (PSU)
+      !!              With other EOS than EOS-80, the salinity is multiplied by a factor 
+      !!              of 35/35.16504 to convert salinity from Absolute to Practical.
+      !!              This approximation leads to a ~0.003.degrees rms difference with the
+      !!              exact value of the freezing point.  
+      !!
       !! Reference  :   UNESCO tech. papers in the marine science no. 28. 1978
       !!----------------------------------------------------------------------
@@ -1009,34 +1020,11 @@
       !!----------------------------------------------------------------------
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE ( -1, 1 )                !==  CT,SA (TEOS-10 formulation) ==!
-         !
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               zs= SQRT( ABS( psal(ji,jj) ) * r1_S0 )           ! square root salinity
-               ptf(ji,jj) = ((((1.46873e-03_wp*zs-9.64972e-03_wp)*zs+2.28348e-02_wp)*zs &
-                  &          - 3.12775e-02_wp)*zs+2.07679e-02_wp)*zs-5.87701e-02_wp
-            END DO
-         END DO
-         ptf(:,:) = ptf(:,:) * psal(:,:)
-         !
-         IF( PRESENT( pdep ) )   ptf(:,:) = ptf(:,:) - 7.53e-4 * pdep(:,:)
-         !
-      CASE ( 0 )                     !==  PT,SP (UNESCO formulation)  ==!
-         !
-         ptf(:,:) = ( - 0.0575_wp + 1.710523e-3_wp * SQRT( psal(:,:) )   &
-            &                     - 2.154996e-4_wp *       psal(:,:)   ) * psal(:,:)
-            !
-         IF( PRESENT( pdep ) )   ptf(:,:) = ptf(:,:) - 7.53e-4 * pdep(:,:)
-         !
-      CASE DEFAULT
-         IF(lwp) WRITE(numout,cform_err)
-         IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
-         nstop = nstop + 1
-         !
-      END SELECT      
+      ptf(:,:) = ( - 0.0575_wp + 1.710523e-3_wp * SQRT( psal(:,:) * rSA2SP )   &
+         &                     - 2.154996e-4_wp *       psal(:,:) * rSA2SP   ) * psal(:,:) * rSA2SP
+         !
+      IF( PRESENT( pdep ) )   ptf(:,:) = ptf(:,:) - 7.53e-4 * pdep(:,:)
       !
   END SUBROUTINE eos_fzp_2d
+
 
   SUBROUTINE eos_fzp_0d( psal, ptf, pdep )
@@ -1059,28 +1047,8 @@
       !!----------------------------------------------------------------------
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE ( -1, 1 )                !==  CT,SA (TEOS-10 formulation) ==!
-         !
-         zs  = SQRT( ABS( psal ) * r1_S0 )           ! square root salinity
-         ptf = ((((1.46873e-03_wp*zs-9.64972e-03_wp)*zs+2.28348e-02_wp)*zs &
-                  &          - 3.12775e-02_wp)*zs+2.07679e-02_wp)*zs-5.87701e-02_wp
-         ptf = ptf * psal
-         !
-         IF( PRESENT( pdep ) )   ptf = ptf - 7.53e-4 * pdep
-         !
-      CASE ( 0 )                     !==  PT,SP (UNESCO formulation)  ==!
-         !
-         ptf = ( - 0.0575_wp + 1.710523e-3_wp * SQRT( psal )   &
-            &                - 2.154996e-4_wp *       psal   ) * psal
-            !
-         IF( PRESENT( pdep ) )   ptf = ptf - 7.53e-4 * pdep
-         !
-      CASE DEFAULT
-         IF(lwp) WRITE(numout,cform_err)
-         IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
-         nstop = nstop + 1
-         !
-      END SELECT
+      ptf = ( - 0.0575_wp + 1.710523e-3_wp * SQRT( psal * rSA2SP )   &
+         &                - 2.154996e-4_wp *       psal * rSA2SP   ) * psal * rSA2SP
+         !
+      IF( PRESENT( pdep ) )   ptf = ptf - 7.53e-4 * pdep
       !
    END SUBROUTINE eos_fzp_0d
@@ -1109,5 +1077,5 @@
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(in   ) ::   pts     ! pot. temperature & salinity
       REAL(wp), DIMENSION(jpi,jpj,jpk,jpts), INTENT(  out) ::   pab_pe  ! alpha_pe and beta_pe
-      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   ppen     ! potential energy anomaly
+      REAL(wp), DIMENSION(jpi,jpj,jpk)     , INTENT(  out) ::   ppen    ! potential energy anomaly
       !
       INTEGER  ::   ji, jj, jk                ! dummy loop indices
@@ -1118,7 +1086,7 @@
       IF( nn_timing == 1 )   CALL timing_start('eos_pen')
       !
-      SELECT CASE ( nn_eos )
-      !
-      CASE( -1, 0 )                !==  polynomial TEOS-10 / EOS-80 ==!
+      SELECT CASE ( neos )
+      !
+      CASE( np_teos10 , np_eos80 )               !==  polynomial TEOS-10 or EOS-80 ==!
          !
          DO jk = 1, jpkm1
@@ -1183,19 +1151,19 @@
          END DO
          !
-      CASE( 1 )                !==  Vallis (2006) simplified EOS  ==!
+      CASE( np_seos , np_leos )                !==  simplified or linear EOS  ==!
          !
          DO jk = 1, jpkm1
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zt  = pts(ji,jj,jk,jp_tem) - 10._wp  ! temperature anomaly (t-T0)
-                  zs = pts (ji,jj,jk,jp_sal) - 35._wp  ! abs. salinity anomaly (s-S0)
+                  zt  = pts(ji,jj,jk,jp_tem) - ST0     ! temperature anomaly (t-T0)
+                  zs  = pts(ji,jj,jk,jp_sal) - 35._wp  ! abs. salinity anomaly (s-S0)
                   zh  = gdept_n(ji,jj,jk)              ! depth in meters  at t-point
                   ztm = tmask(ji,jj,jk)                ! tmask
                   zn  = 0.5_wp * zh * r1_rau0 * ztm
                   !                                    ! Potential Energy
-                  ppen(ji,jj,jk) = ( rn_a0 * rn_mu1 * zt + rn_b0 * rn_mu2 * zs ) * zn
+                  ppen(ji,jj,jk) = STH * zt * zn
                   !                                    ! alphaPE
-                  pab_pe(ji,jj,jk,jp_tem) = - rn_a0 * rn_mu1 * zn
-                  pab_pe(ji,jj,jk,jp_sal) =   rn_b0 * rn_mu2 * zn
+                  pab_pe(ji,jj,jk,jp_tem) = - STH * zn
+                  pab_pe(ji,jj,jk,jp_sal) =   0._wp
                   !
                END DO
@@ -1205,5 +1173,5 @@
       CASE DEFAULT
          IF(lwp) WRITE(numout,cform_err)
-         IF(lwp) WRITE(numout,*) '          bad flag value for nn_eos = ', nn_eos
+         IF(lwp) WRITE(numout,*) '          bad flag value for neos = ', neos
          nstop = nstop + 1
          !
@@ -1223,8 +1191,9 @@
       !! ** Method  :   Read the namelist nameos and control the parameters
       !!----------------------------------------------------------------------
-      INTEGER  ::   ios   ! local integer
-      !!
-      NAMELIST/nameos/ nn_eos, ln_useCT, rn_a0, rn_b0, rn_lambda1, rn_mu1,   &
-         &                                             rn_lambda2, rn_mu2, rn_nu
+      INTEGER  ::   ios, ioptio   ! local integer
+      !!
+      NAMELIST/nameos/ ln_TEOS10, ln_EOS80, ln_SEOS, ln_LEOS,   &    ! EOS choice
+         &             rn_a0, rn_b0, rn_cb, rn_t0, rn_th,       &    ! S-EOS parameters
+         &             rn_al, rn_bl                                  ! L-EOS   -   -
       !!----------------------------------------------------------------------
       !
@@ -1238,6 +1207,6 @@
       IF(lwm) WRITE( numond, nameos )
       !
-      rau0        = 1026._wp                 !: volumic mass of reference     [kg/m3]
-      rcp         = 3991.86795711963_wp      !: heat capacity     [J/K]
+      rau0 = 1026._wp                 !: density of reference   [kg/m3]
+      rcp  = 3991.86795711963_wp      !: heat capacity          [J/K]
       !
       IF(lwp) THEN                ! Control print
@@ -1245,19 +1214,27 @@
          WRITE(numout,*) 'eos_init : equation of state'
          WRITE(numout,*) '~~~~~~~~'
-         WRITE(numout,*) '          Namelist nameos : set eos parameters'
-         WRITE(numout,*) '             flag for eq. of state and N^2  nn_eos   = ', nn_eos
-         IF( ln_useCT )   THEN
-            WRITE(numout,*) '             model uses Conservative Temperature'
-            WRITE(numout,*) '             Important: model must be initialized with CT and SA fields'
-         ELSE
-            WRITE(numout,*) '             model does not use Conservative Temperature'
-         ENDIF
+         WRITE(numout,*) '   Namelist nameos : Chosen the Equation Of Seawater (EOS)'
+         WRITE(numout,*) '      TEOS-10 : rho(Conservative Temperature, Absolute  Salinity, depth)   ln_TEOS10 = ', ln_TEOS10
+         WRITE(numout,*) '      EOS-80  : rho(Potential    Temperature, Practical Salinity, depth)   ln_EOS80  = ', ln_EOS80
+         WRITE(numout,*) '      S-EOS   : rho(Conservative Temperature, Absolute  Salinity, depth)   ln_SEOS   = ', ln_SEOS
+         WRITE(numout,*) '      L-EOS   : rho(Conservative Temperature, Absolute  Salinity       )   ln_LEOS   = ', ln_LEOS
       ENDIF
-      !
-      SELECT CASE( nn_eos )         ! check option
-      !
-      CASE( -1 )                       !==  polynomial TEOS-10  ==!
+
+      ! Check options for equation of state & set neos based on logical flags
+      ioptio = 0
+      IF( ln_TEOS10 ) THEN   ;   ioptio = ioptio+1   ;   neos = np_teos10   ;   ENDIF
+      IF( ln_EOS80  ) THEN   ;   ioptio = ioptio+1   ;   neos = np_eos80    ;   ENDIF
+      IF( ln_SEOS   ) THEN   ;   ioptio = ioptio+1   ;   neos = np_seos     ;   ENDIF
+      IF( ln_LEOS   ) THEN   ;   ioptio = ioptio+1   ;   neos = np_leos     ;   ENDIF
+      IF( ioptio /= 1 )   CALL ctl_stop("Exactly one equation of state option must be selected")
+      !
+      SELECT CASE( neos )         ! check option
+      !
+      CASE( np_teos10 )                       !==  polynomial TEOS-10  ==!
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '          use of TEOS-10 equation of state (cons. temp. and abs. salinity)'
+         !
+         l_useCT = .TRUE.                          ! model temperature is Conservative temperature 
+         rSA2SP  = 35._wp / 35.16504_wp            ! model salinity is Absolute Salinity (= conversion from SA to SP)
          !
          rdeltaS = 32._wp
@@ -1446,8 +1423,11 @@
          BPE002 = 1.7269476440e-04_wp
          !
-      CASE( 0 )                        !==  polynomial EOS-80 formulation  ==!
+      CASE( np_eos80 )                        !==  polynomial EOS-80 formulation  ==!
          !
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '          use of EOS-80 equation of state (pot. temp. and pract. salinity)'
+         !
+         l_useCT = .FALSE.                         ! model temperature is Potential temperature
+         rSA2SP  = 1._wp                           ! model salinity is SP (Practical Salinity) ==>> rSA2SP=1
          !
          rdeltaS = 20._wp
